Noccy's HotFixes
================

## How do I install the hotfix utility?

### Automated installation

The automated installer has been tested on Ubuntu 16.04.1, and it does all the
heavy lifting for you, including dependencies.

    $ sudo apt install curl
    $ curl -O hotfix-installer.run http://files.noccy.com/hotfix/hotfix-installer.run
    $ chmod +x hotfix-installer.run
    $ ./hotfix-installer.run

### Manual install

If you would like to install it manually:

    $ curl -O ~/bin/hotfix http://files.noccy.com/hotfix/hotfix
    $ chmod +x ~/bin/hotfix

## Using Hotfixes

To use a hotfix, you need to have the publishers public key imported. For my hotfixes,
you need to do:

    $ curl http://files.noccy.com/hotfix/signing-key.asc | gpg --import -

Next, create a file at `~/.hotfix.conf` containing:

    [alias]
    noccy=http://files.noccy.com/hotfix/{fix}.fix.signed

And finally, apply the desired hotfix:

    $ hotfix apply noccy:install-processing

Without a defined alias you would do:

    $ hotfix apply http://files.noccy.com/hotfix/install-processing.fix.signed

## Publishing Hotfixes

1.  Create your hotfix in a text editor. You can use one of the examples as a
    starting point.
2.  Test the fix locally, using `hotfix apply -I <file>` to make sure it works
    as intended.
3.  Once everything works as intended, sign the hotfix using `hotfix sign <file>`
    and upload the `.fix.signed` file to your location of choice.
4.  Put a link to your public key in your forum signature, on your about page etc.
5.  Publish your fix together with the relevant information.